portaudio.h File Reference
Public API definitions for users of PortAudio

The portable PortAudio API. More...

Go to the source code of this file.

## Data Structures

struct | PaVersionInfo
struct | PaHostApiInfo
struct | PaHostErrorInfo
struct | PaDeviceInfo
struct | PaStreamParameters
struct | PaStreamCallbackTimeInfo
struct | PaStreamInfo

## Macros

#define | paMakeVersionNumber(major, minor, subminor) (((major)&0xFF)<<16 | ((minor)&0xFF)<<8 | ((subminor)&0xFF))
#define | paNoDevice ((PaDeviceIndex)-1)
#define | paUseHostApiSpecificDeviceSpecification ((PaDeviceIndex)-2)
#define | paFloat32 ((PaSampleFormat) 0x00000001)
#define | paInt32 ((PaSampleFormat) 0x00000002)
#define | paInt24 ((PaSampleFormat) 0x00000004)
#define | paInt16 ((PaSampleFormat) 0x00000008)
#define | paInt8 ((PaSampleFormat) 0x00000010)
#define | paUInt8 ((PaSampleFormat) 0x00000020)
#define | paCustomFormat ((PaSampleFormat) 0x00010000)
#define | paNonInterleaved ((PaSampleFormat) 0x80000000)
#define | paFormatIsSupported (0)
#define | paFramesPerBufferUnspecified (0)
#define | paNoFlag ((PaStreamFlags) 0)
#define | paClipOff ((PaStreamFlags) 0x00000001)
#define | paDitherOff ((PaStreamFlags) 0x00000002)
#define | paNeverDropInput ((PaStreamFlags) 0x00000004)
#define | paPrimeOutputBuffersUsingStreamCallback ((PaStreamFlags) 0x00000008)
#define | paPlatformSpecificFlags ((PaStreamFlags)0xFFFF0000)
#define | paInputUnderflow ((PaStreamCallbackFlags) 0x00000001)
#define | paInputOverflow ((PaStreamCallbackFlags) 0x00000002)
#define | paOutputUnderflow ((PaStreamCallbackFlags) 0x00000004)
#define | paOutputOverflow ((PaStreamCallbackFlags) 0x00000008)
#define | paPrimingOutput ((PaStreamCallbackFlags) 0x00000010)

## Typedefs

typedef struct PaVersionInfo | PaVersionInfo
typedef int | PaError
typedef enum PaErrorCode | PaErrorCode
typedef int | PaDeviceIndex
typedef int | PaHostApiIndex
typedef enum PaHostApiTypeId | PaHostApiTypeId
typedef struct PaHostApiInfo | PaHostApiInfo
typedef struct PaHostErrorInfo | PaHostErrorInfo
typedef double | PaTime
typedef unsigned long | PaSampleFormat
typedef struct PaDeviceInfo | PaDeviceInfo
typedef struct PaStreamParameters | PaStreamParameters
typedef void | PaStream
typedef unsigned long | PaStreamFlags
typedef struct PaStreamCallbackTimeInfo | PaStreamCallbackTimeInfo
typedef unsigned long | PaStreamCallbackFlags
typedef enum PaStreamCallbackResult | PaStreamCallbackResult
typedef int | PaStreamCallback(const void *input, void *output, unsigned long frameCount, const PaStreamCallbackTimeInfo *timeInfo, PaStreamCallbackFlags statusFlags, void *userData)
typedef void | PaStreamFinishedCallback(void *userData)
typedef struct PaStreamInfo | PaStreamInfo

## Enumerations

enum

PaErrorCode {
paNoError = 0, paNotInitialized = -10000, paUnanticipatedHostError, paInvalidChannelCount,
paInvalidSampleRate, paInvalidDevice, paInvalidFlag, paSampleFormatNotSupported,
paBadIODeviceCombination, paInsufficientMemory, paBufferTooBig, paBufferTooSmall,
paNullCallback, paBadStreamPtr, paTimedOut, paInternalError,
paDeviceUnavailable, paIncompatibleHostApiSpecificStreamInfo, paStreamIsStopped, paStreamIsNotStopped,
paInputOverflowed, paOutputUnderflowed, paHostApiNotFound, paInvalidHostApi,
paCanNotReadFromACallbackStream, paCanNotWriteToACallbackStream, paCanNotReadFromAnOutputOnlyStream, paCanNotWriteToAnInputOnlyStream,
paIncompatibleStreamHostApi, paBadBufferPtr
}

enum | PaHostApiTypeId { paInDevelopment =0, paDirectSound =1, paMME =2, paASIO =3, paSoundManager =4, paCoreAudio =5, paOSS =7, paALSA =8, paAL =9, paBeOS =10, paWDMKS =11, paJACK =12, paWASAPI =13, paAudioScienceHPI =14 }
enum | PaStreamCallbackResult { paContinue =0, paComplete =1, paAbort =2 }

## Functions

int | Pa_GetVersion (void)
const char * | Pa_GetVersionText (void)
const PaVersionInfo * | Pa_GetVersionInfo ()
const char * | Pa_GetErrorText (PaError errorCode)
PaError | Pa_Initialize (void)
PaError | Pa_Terminate (void)
PaHostApiIndex | Pa_GetHostApiCount (void)
PaHostApiIndex | Pa_GetDefaultHostApi (void)
const PaHostApiInfo * | Pa_GetHostApiInfo (PaHostApiIndex hostApi)
PaHostApiIndex | Pa_HostApiTypeIdToHostApiIndex (PaHostApiTypeId type)
PaDeviceIndex | Pa_HostApiDeviceIndexToDeviceIndex (PaHostApiIndex hostApi, int hostApiDeviceIndex)
const PaHostErrorInfo * | Pa_GetLastHostErrorInfo (void)
PaDeviceIndex | Pa_GetDeviceCount (void)
PaDeviceIndex | Pa_GetDefaultInputDevice (void)
PaDeviceIndex | Pa_GetDefaultOutputDevice (void)
const PaDeviceInfo * | Pa_GetDeviceInfo (PaDeviceIndex device)
PaError | Pa_IsFormatSupported (const PaStreamParameters *inputParameters, const PaStreamParameters *outputParameters, double sampleRate)
PaError | Pa_OpenStream (PaStream **stream, const PaStreamParameters *inputParameters, const PaStreamParameters *outputParameters, double sampleRate, unsigned long framesPerBuffer, PaStreamFlags streamFlags, PaStreamCallback *streamCallback, void *userData)
PaError | Pa_OpenDefaultStream (PaStream **stream, int numInputChannels, int numOutputChannels, PaSampleFormat sampleFormat, double sampleRate, unsigned long framesPerBuffer, PaStreamCallback *streamCallback, void *userData)
PaError | Pa_CloseStream (PaStream *stream)
PaError | Pa_SetStreamFinishedCallback (PaStream *stream, PaStreamFinishedCallback *streamFinishedCallback)
PaError | Pa_StartStream (PaStream *stream)
PaError | Pa_StopStream (PaStream *stream)
PaError | Pa_AbortStream (PaStream *stream)
PaError | Pa_IsStreamStopped (PaStream *stream)
PaError | Pa_IsStreamActive (PaStream *stream)
const PaStreamInfo * | Pa_GetStreamInfo (PaStream *stream)
PaTime | Pa_GetStreamTime (PaStream *stream)
double | Pa_GetStreamCpuLoad (PaStream *stream)
PaError | Pa_ReadStream (PaStream *stream, void *buffer, unsigned long frames)
PaError | Pa_WriteStream (PaStream *stream, const void *buffer, unsigned long frames)
signed long | Pa_GetStreamReadAvailable (PaStream *stream)
signed long | Pa_GetStreamWriteAvailable (PaStream *stream)
PaHostApiTypeId | Pa_GetStreamHostApiType (PaStream *stream)
PaError | Pa_GetSampleSize (PaSampleFormat format)
void | Pa_Sleep (long msec)

## Detailed Description

The portable PortAudio API.

Definition in file portaudio.h.

## Macro Definition Documentation

## paClipOff

#define paClipOff ((PaStreamFlags) 0x00000001)

Disable default clipping of out of range samples.

See also
  PaStreamFlags

Definition at line 661 of file portaudio.h.

## paCustomFormat

#define paCustomFormat ((PaSampleFormat) 0x00010000)

See also
  PaSampleFormat

Definition at line 493 of file portaudio.h.

## paDitherOff

#define paDitherOff ((PaStreamFlags) 0x00000002)

Disable default dithering.

See also
  PaStreamFlags

Definition at line 666 of file portaudio.h.

## paFloat32

#define paFloat32 ((PaSampleFormat) 0x00000001)

See also
  PaSampleFormat

Definition at line 487 of file portaudio.h.

## paFormatIsSupported

#define paFormatIsSupported (0)

Return code for Pa_IsFormatSupported indicating success.

Definition at line 585 of file portaudio.h.

## paFramesPerBufferUnspecified

#define paFramesPerBufferUnspecified (0)

Can be passed as the framesPerBuffer parameter to Pa_OpenStream() or Pa_OpenDefaultStream() to indicate that the stream callback will accept buffers of any size.

Definition at line 642 of file portaudio.h.

## paInputOverflow

#define paInputOverflow ((PaStreamCallbackFlags) 0x00000002)

In a stream opened with paFramesPerBufferUnspecified, indicates that data prior to the first sample of the input buffer was discarded due to an overflow, possibly because the stream callback is using too much CPU time. Otherwise indicates that data prior to one or more samples in the input buffer was discarded.

See also
  PaStreamCallbackFlags

Definition at line 730 of file portaudio.h.

## paInputUnderflow

#define paInputUnderflow ((PaStreamCallbackFlags) 0x00000001)

In a stream opened with paFramesPerBufferUnspecified, indicates that input data is all silence (zeros) because no real data is available. In a stream opened without paFramesPerBufferUnspecified, it indicates that one or more zero samples have been inserted into the input buffer to compensate for an input underflow.

See also
  PaStreamCallbackFlags

Definition at line 721 of file portaudio.h.

## paInt16

#define paInt16 ((PaSampleFormat) 0x00000008)

See also
  PaSampleFormat

Definition at line 490 of file portaudio.h.

## paInt24

#define paInt24 ((PaSampleFormat) 0x00000004)

Packed 24 bit format.

See also
  PaSampleFormat

Definition at line 489 of file portaudio.h.

## paInt32

#define paInt32 ((PaSampleFormat) 0x00000002)

See also
  PaSampleFormat

Definition at line 488 of file portaudio.h.

## paInt8

#define paInt8 ((PaSampleFormat) 0x00000010)

See also
  PaSampleFormat

Definition at line 491 of file portaudio.h.

## paMakeVersionNumber

#define paMakeVersionNumber | ( |  | major,
|  |  | minor,
|  |  | subminor
| ) |  | (((major)&0xFF)<<16 | ((minor)&0xFF)<<8 | ((subminor)&0xFF))

Generate a packed integer version number in the same format used by Pa_GetVersion(). Use this to compare a specified version number with the currently running version. For example:

if( Pa_GetVersion() < paMakeVersionNumber(19,5,1) ) {}

See also
  Pa_GetVersion, Pa_GetVersionInfo

Version
  Available as of 19.5.0.

Definition at line 81 of file portaudio.h.

## paNeverDropInput

#define paNeverDropInput ((PaStreamFlags) 0x00000004)

Flag requests that where possible a full duplex stream will not discard overflowed input samples without calling the stream callback. This flag is only valid for full duplex callback streams and only when used in combination with the paFramesPerBufferUnspecified (0) framesPerBuffer parameter. Using this flag incorrectly results in a paInvalidFlag error being returned from Pa_OpenStream and Pa_OpenDefaultStream.

See also
  PaStreamFlags, paFramesPerBufferUnspecified

Definition at line 677 of file portaudio.h.

## paNoDevice

#define paNoDevice ((PaDeviceIndex)-1)

A special PaDeviceIndex value indicating that no device is available, or should be used.

See also
  PaDeviceIndex

Definition at line 220 of file portaudio.h.

## paNoFlag

#define paNoFlag ((PaStreamFlags) 0)

See also
  PaStreamFlags

Definition at line 656 of file portaudio.h.

## paNonInterleaved

#define paNonInterleaved ((PaSampleFormat) 0x80000000)

See also
  PaSampleFormat

Definition at line 495 of file portaudio.h.

## paOutputOverflow

#define paOutputOverflow ((PaStreamCallbackFlags) 0x00000008)

Indicates that output data will be discarded because no room is available.

See also
  PaStreamCallbackFlags

Definition at line 741 of file portaudio.h.

## paOutputUnderflow

#define paOutputUnderflow ((PaStreamCallbackFlags) 0x00000004)

Indicates that output data (or a gap) was inserted, possibly because the stream callback is using too much CPU time.

See also
  PaStreamCallbackFlags

Definition at line 736 of file portaudio.h.

## paPlatformSpecificFlags

#define paPlatformSpecificFlags ((PaStreamFlags)0xFFFF0000)

A mask specifying the platform specific bits.

See also
  PaStreamFlags

Definition at line 690 of file portaudio.h.

## paPrimeOutputBuffersUsingStreamCallback

#define paPrimeOutputBuffersUsingStreamCallback ((PaStreamFlags) 0x00000008)

Call the stream callback to fill initial output buffers, rather than the default behavior of priming the buffers with zeros (silence). This flag has no effect for input-only and blocking read/write streams.

See also
  PaStreamFlags

Definition at line 685 of file portaudio.h.

## paPrimingOutput

#define paPrimingOutput ((PaStreamCallbackFlags) 0x00000010)

Some of all of the output data will be used to prime the stream, input data may be zero.

See also
  PaStreamCallbackFlags

Definition at line 747 of file portaudio.h.

## paUInt8

#define paUInt8 ((PaSampleFormat) 0x00000020)

See also
  PaSampleFormat

Definition at line 492 of file portaudio.h.

## paUseHostApiSpecificDeviceSpecification

#define paUseHostApiSpecificDeviceSpecification ((PaDeviceIndex)-2)

A special PaDeviceIndex value indicating that the device(s) to be used are specified in the host api specific stream info structure.

See also
  PaDeviceIndex

Definition at line 228 of file portaudio.h.

## Typedef Documentation

## PaDeviceIndex

typedef int PaDeviceIndex

The type used to refer to audio devices. Values of this type usually range from 0 to (Pa_GetDeviceCount()-1), and may also take on the PaNoDevice and paUseHostApiSpecificDeviceSpecification values.

See also
  Pa_GetDeviceCount, paNoDevice, paUseHostApiSpecificDeviceSpecification

Definition at line 212 of file portaudio.h.

## PaDeviceInfo

typedef struct PaDeviceInfo PaDeviceInfo

A structure providing information and capabilities of PortAudio devices. Devices may support input, output or both input and output.

## PaError

typedef int PaError

Error codes returned by PortAudio functions. Note that with the exception of paNoError, all PaErrorCodes are negative.

Definition at line 121 of file portaudio.h.

## PaHostApiIndex

typedef int PaHostApiIndex

The type used to enumerate to host APIs at runtime. Values of this type range from 0 to (Pa_GetHostApiCount()-1).

See also
  Pa_GetHostApiCount

Definition at line 238 of file portaudio.h.

## PaHostApiInfo

typedef struct PaHostApiInfo PaHostApiInfo

A structure containing information about a particular host API.

## PaHostApiTypeId

typedef enum PaHostApiTypeId PaHostApiTypeId

Unchanging unique identifiers for each supported host API. This type is used in the PaHostApiInfo structure. The values are guaranteed to be unique and to never change, thus allowing code to be written that conditionally uses host API specific extensions.

New type ids will be allocated when support for a host API reaches "public alpha" status, prior to that developers should use the paInDevelopment type id.

See also
  PaHostApiInfo

## PaHostErrorInfo

typedef struct PaHostErrorInfo PaHostErrorInfo

Structure used to return information about a host error condition.

## PaSampleFormat

typedef unsigned long PaSampleFormat

A type used to specify one or more sample formats. Each value indicates a possible format for sound data passed to and from the stream callback, Pa_ReadStream and Pa_WriteStream.

The standard formats paFloat32, paInt16, paInt32, paInt24, paInt8 and aUInt8 are usually implemented by all implementations.

The floating point representation (paFloat32) uses +1.0 and -1.0 as the maximum and minimum respectively.

paUInt8 is an unsigned 8 bit format where 128 is considered "ground"

The paNonInterleaved flag indicates that audio data is passed as an array of pointers to separate buffers, one buffer for each channel. Usually, when this flag is not used, audio data is passed as a single buffer with all channels interleaved.

See also
  Pa_OpenStream, Pa_OpenDefaultStream, PaDeviceInfo
  paFloat32, paInt16, paInt32, paInt24, paInt8
  paUInt8, paCustomFormat, paNonInterleaved

Definition at line 484 of file portaudio.h.

## PaStream

typedef void PaStream

A single PaStream can provide multiple channels of real-time streaming audio input and output to a client application. A stream provides access to audio hardware represented by one or more PaDevices. Depending on the underlying Host API, it may be possible to open multiple streams using the same device, however this behavior is implementation defined. Portable applications should assume that a PaDevice may be simultaneously used by at most one PaStream.

Pointers to PaStream objects are passed between PortAudio functions that operate on streams.

See also
  Pa_OpenStream, Pa_OpenDefaultStream, Pa_OpenDefaultStream, Pa_CloseStream, Pa_StartStream, Pa_StopStream, Pa_AbortStream, Pa_IsStreamActive, Pa_GetStreamTime, Pa_GetStreamCpuLoad

Definition at line 635 of file portaudio.h.

## PaStreamCallback

typedef int PaStreamCallback(const void *input, void *output, unsigned long frameCount, const PaStreamCallbackTimeInfo *timeInfo, PaStreamCallbackFlags statusFlags, void *userData)

Functions of type PaStreamCallback are implemented by PortAudio clients. They consume, process or generate audio in response to requests from an active PortAudio stream.

When a stream is running, PortAudio calls the stream callback periodically. The callback function is responsible for processing buffers of audio samples passed via the input and output parameters.

The PortAudio stream callback runs at very high or real-time priority. It is required to consistently meet its time deadlines. Do not allocate memory, access the file system, call library functions or call other functions from the stream callback that may block or take an unpredictable amount of time to complete.

In order for a stream to maintain glitch-free operation the callback must consume and return audio data faster than it is recorded and/or played. PortAudio anticipates that each callback invocation may execute for a duration approaching the duration of frameCount audio frames at the stream sample rate. It is reasonable to expect to be able to utilise 70% or more of the available CPU time in the PortAudio callback. However, due to buffer size adaption and other factors, not all host APIs are able to guarantee audio stability under heavy CPU load with arbitrary fixed callback buffer sizes. When high callback CPU utilisation is required the most robust behavior can be achieved by using paFramesPerBufferUnspecified as the Pa_OpenStream() framesPerBuffer parameter.

Parameters

  input | and
  output | are either arrays of interleaved samples or; if non-interleaved samples were requested using the paNonInterleaved sample format flag, an array of buffer pointers, one non-interleaved buffer for each channel.

The format, packing and number of channels used by the buffers are determined by parameters to Pa_OpenStream().

Parameters

  frameCount | The number of sample frames to be processed by the stream callback.
  timeInfo | Timestamps indicating the ADC capture time of the first sample in the input buffer, the DAC output time of the first sample in the output buffer and the time the callback was invoked. See PaStreamCallbackTimeInfo and Pa_GetStreamTime()
  statusFlags | Flags indicating whether input and/or output buffers have been inserted or will be dropped to overcome underflow or overflow conditions.
  userData | The value of a user supplied pointer passed to Pa_OpenStream() intended for storing synthesis data etc.

Returns
  The stream callback should return one of the values in the PaStreamCallbackResult enumeration. To ensure that the callback continues to be called, it should return paContinue (0). Either paComplete or paAbort can be returned to finish stream processing, after either of these values is returned the callback will not be called again. If paAbort is returned the stream will finish as soon as possible. If paComplete is returned, the stream will continue until all buffers generated by the callback have been played. This may be useful in applications such as soundfile players where a specific duration of output is required. However, it is not necessary to utilize this mechanism as Pa_StopStream(), Pa_AbortStream() or Pa_CloseStream() can also be used to stop the stream. The callback must always fill the entire output buffer irrespective of its return value.

See also
  Pa_OpenStream, Pa_OpenDefaultStream

Note
  With the exception of Pa_GetStreamCpuLoad() it is not permissible to call PortAudio API functions from within the stream callback.

Definition at line 830 of file portaudio.h.

## PaStreamCallbackFlags

typedef unsigned long PaStreamCallbackFlags

Flag bit constants for the statusFlags to PaStreamCallback.

See also
  paInputUnderflow, paInputOverflow, paOutputUnderflow, paOutputOverflow, paPrimingOutput

Definition at line 712 of file portaudio.h.

## PaStreamCallbackResult

typedef enum PaStreamCallbackResult PaStreamCallbackResult

Allowable return values for the PaStreamCallback.

See also
  PaStreamCallback

## PaStreamCallbackTimeInfo

typedef struct PaStreamCallbackTimeInfo PaStreamCallbackTimeInfo

Timing information for the buffers passed to the stream callback.

Time values are expressed in seconds and are synchronised with the time base used by Pa_GetStreamTime() for the associated stream.

See also
  PaStreamCallback, Pa_GetStreamTime

## PaStreamFinishedCallback

typedef void PaStreamFinishedCallback(void *userData)

Functions of type PaStreamFinishedCallback are implemented by PortAudio clients. They can be registered with a stream using the Pa_SetStreamFinishedCallback function. Once registered they are called when the stream becomes inactive (ie once a call to Pa_StopStream() will not block). A stream will become inactive after the stream callback returns non-zero, or when Pa_StopStream or Pa_AbortStream is called. For a stream providing audio output, if the stream callback returns paComplete, or Pa_StopStream() is called, the stream finished callback will not be called until all generated sample data has been played.

Parameters

  userData | The userData parameter supplied to Pa_OpenStream()

See also
  Pa_SetStreamFinishedCallback

Definition at line 962 of file portaudio.h.

## PaStreamFlags

typedef unsigned long PaStreamFlags

Flags used to control the behavior of a stream. They are passed as parameters to Pa_OpenStream or Pa_OpenDefaultStream. Multiple flags may be ORed together.

See also
  Pa_OpenStream, Pa_OpenDefaultStream
  paNoFlag, paClipOff, paDitherOff, paNeverDropInput, paPrimeOutputBuffersUsingStreamCallback, paPlatformSpecificFlags

Definition at line 653 of file portaudio.h.

## PaStreamInfo

typedef struct PaStreamInfo PaStreamInfo

A structure containing unchanging information about an open stream.

See also
  Pa_GetStreamInfo

## PaStreamParameters

typedef struct PaStreamParameters PaStreamParameters

Parameters for one direction (input or output) of a stream.

## PaTime

typedef double PaTime

The type used to represent monotonic time in seconds. PaTime is used for the fields of the PaStreamCallbackTimeInfo argument to the PaStreamCallback and as the result of Pa_GetStreamTime().

PaTime values have unspecified origin.

See also
  PaStreamCallback, PaStreamCallbackTimeInfo, Pa_GetStreamTime

Definition at line 460 of file portaudio.h.

## PaVersionInfo

typedef struct PaVersionInfo PaVersionInfo

A structure containing PortAudio API version information.

See also
  Pa_GetVersionInfo, paMakeVersionNumber

Version
  Available as of 19.5.0.

## Enumeration Type Documentation

## PaHostApiTypeId

enum PaHostApiTypeId

Unchanging unique identifiers for each supported host API. This type is used in the PaHostApiInfo structure. The values are guaranteed to be unique and to never change, thus allowing code to be written that conditionally uses host API specific extensions.

New type ids will be allocated when support for a host API reaches "public alpha" status, prior to that developers should use the paInDevelopment type id.

See also
  PaHostApiInfo

Definition at line 275 of file portaudio.h.

## PaStreamCallbackResult

enum PaStreamCallbackResult

Allowable return values for the PaStreamCallback.

See also
  PaStreamCallback

Enumerator
paContinue | Signal that the stream should continue invoking the callback and processing audio.
paComplete | Signal that the stream should stop invoking the callback and finish once all output samples have played.
paAbort | Signal that the stream should stop invoking the callback and finish as soon as possible.

Definition at line 753 of file portaudio.h.

## Function Documentation

## Pa_AbortStream()

PaError Pa_AbortStream | ( | PaStream * | stream | ) |

Terminates audio processing immediately without waiting for pending buffers to complete.

## Pa_CloseStream()

PaError Pa_CloseStream | ( | PaStream * | stream | ) |

Closes an audio stream. If the audio stream is active it discards any pending buffers as if Pa_AbortStream() had been called.

## Pa_GetDefaultHostApi()

PaHostApiIndex Pa_GetDefaultHostApi | ( | void |  | ) |

Retrieve the index of the default host API. The default host API will be the lowest common denominator host API on the current platform and is unlikely to provide the best performance.

Returns
  A non-negative value ranging from 0 to (Pa_GetHostApiCount()-1) indicating the default host API index or, a PaErrorCode (which are always negative) if PortAudio is not initialized or an error is encountered.

## Pa_GetDefaultInputDevice()

PaDeviceIndex Pa_GetDefaultInputDevice | ( | void |  | ) |

Retrieve the index of the default input device. The result can be used in the inputDevice parameter to Pa_OpenStream().

Returns
  The default input device index for the default host API, or paNoDevice if no default input device is available or an error was encountered.

## Pa_GetDefaultOutputDevice()

PaDeviceIndex Pa_GetDefaultOutputDevice | ( | void |  | ) |

Retrieve the index of the default output device. The result can be used in the outputDevice parameter to Pa_OpenStream().

Returns
  The default output device index for the default host API, or paNoDevice if no default output device is available or an error was encountered.

Note
  On the PC, the user can specify a default device by setting an environment variable. For example, to use device #1.

       set PA_RECOMMENDED_OUTPUT_DEVICE=1

  The user should first determine the available device ids by using the supplied application "pa_devs".

## Pa_GetDeviceCount()

PaDeviceIndex Pa_GetDeviceCount | ( | void |  | ) |

Retrieve the number of available devices. The number of available devices may be zero.

Returns
  A non-negative value indicating the number of available devices or, a PaErrorCode (which are always negative) if PortAudio is not initialized or an error is encountered.

## Pa_GetDeviceInfo()

const PaDeviceInfo* Pa_GetDeviceInfo | ( | PaDeviceIndex | device | ) |

Retrieve a pointer to a PaDeviceInfo structure containing information about the specified device.

Returns
  A pointer to an immutable PaDeviceInfo structure. If the device parameter is out of range the function returns NULL.

Parameters

  device | A valid device index in the range 0 to (Pa_GetDeviceCount()-1)

Note
  PortAudio manages the memory referenced by the returned pointer, the client must not manipulate or free the memory. The pointer is only guaranteed to be valid between calls to Pa_Initialize() and Pa_Terminate().

See also
  PaDeviceInfo, PaDeviceIndex

## Pa_GetErrorText()

const char* Pa_GetErrorText | ( | PaError | errorCode | ) |

Translate the supplied PortAudio error code into a human readable message.

## Pa_GetHostApiCount()

PaHostApiIndex Pa_GetHostApiCount | ( | void |  | ) |

Retrieve the number of available host APIs. Even if a host API is available it may have no devices available.

Returns
  A non-negative value indicating the number of available host APIs or, a PaErrorCode (which are always negative) if PortAudio is not initialized or an error is encountered.

See also
  PaHostApiIndex

## Pa_GetHostApiInfo()

const PaHostApiInfo* Pa_GetHostApiInfo | ( | PaHostApiIndex | hostApi | ) |

Retrieve a pointer to a structure containing information about a specific host Api.

Parameters

  hostApi | A valid host API index ranging from 0 to (Pa_GetHostApiCount()-1)

Returns
  A pointer to an immutable PaHostApiInfo structure describing a specific host API. If the hostApi parameter is out of range or an error is encountered, the function returns NULL.

The returned structure is owned by the PortAudio implementation and must not be manipulated or freed. The pointer is only guaranteed to be valid between calls to Pa_Initialize() and Pa_Terminate().

## Pa_GetLastHostErrorInfo()

const PaHostErrorInfo* Pa_GetLastHostErrorInfo | ( | void |  | ) |

Return information about the last host error encountered. The error information returned by Pa_GetLastHostErrorInfo() will never be modified asynchronously by errors occurring in other PortAudio owned threads (such as the thread that manages the stream callback.)

This function is provided as a last resort, primarily to enhance debugging by providing clients with access to all available error information.

Returns
  A pointer to an immutable structure constraining information about the host error. The values in this structure will only be valid if a PortAudio function has previously returned the paUnanticipatedHostError error code.

## Pa_GetSampleSize()

PaError Pa_GetSampleSize | ( | PaSampleFormat | format | ) |

Retrieve the size of a given sample format in bytes.

Returns
  The size in bytes of a single sample in the specified format, or paSampleFormatNotSupported if the format is not supported.

## Pa_GetStreamCpuLoad()

double Pa_GetStreamCpuLoad | ( | PaStream * | stream | ) |

Retrieve CPU usage information for the specified stream. The "CPU Load" is a fraction of total CPU time consumed by a callback stream's audio processing routines including, but not limited to the client supplied stream callback. This function does not work with blocking read/write streams.

This function may be called from the stream callback function or the application.

Returns
  A floating point value, typically between 0.0 and 1.0, where 1.0 indicates that the stream callback is consuming the maximum number of CPU cycles possible to maintain real-time operation. A value of 0.5 would imply that PortAudio and the stream callback was consuming roughly 50% of the available CPU time. The return value may exceed 1.0. A value of 0.0 will always be returned for a blocking read/write stream, or if an error occurs.

## Pa_GetStreamHostApiType()

PaHostApiTypeId Pa_GetStreamHostApiType | ( | PaStream * | stream | ) |

Retrieve the host type handling an open stream.

Returns
  Returns a non-negative value representing the host API type handling an open stream or, a PaErrorCode (which are always negative) if PortAudio is not initialized or an error is encountered.

## Pa_GetStreamInfo()

const PaStreamInfo* Pa_GetStreamInfo | ( | PaStream * | stream | ) |

Retrieve a pointer to a PaStreamInfo structure containing information about the specified stream.

Returns
  A pointer to an immutable PaStreamInfo structure. If the stream parameter is invalid, or an error is encountered, the function returns NULL.

Parameters

  stream | A pointer to an open stream previously created with Pa_OpenStream.

Note
  PortAudio manages the memory referenced by the returned pointer, the client must not manipulate or free the memory. The pointer is only guaranteed to be valid until the specified stream is closed.

See also
  PaStreamInfo

## Pa_GetStreamReadAvailable()

signed long Pa_GetStreamReadAvailable | ( | PaStream * | stream | ) |

Retrieve the number of frames that can be read from the stream without waiting.

Returns
  Returns a non-negative value representing the maximum number of frames that can be read from the stream without blocking or busy waiting or, a PaErrorCode (which are always negative) if PortAudio is not initialized or an error is encountered.

## Pa_GetStreamTime()

PaTime Pa_GetStreamTime | ( | PaStream * | stream | ) |

Returns the current time in seconds for a stream according to the same clock used to generate callback PaStreamCallbackTimeInfo timestamps. The time values are monotonically increasing and have unspecified origin.

Pa_GetStreamTime returns valid time values for the entire life of the stream, from when the stream is opened until it is closed. Starting and stopping the stream does not affect the passage of time returned by Pa_GetStreamTime.

This time may be used for synchronizing other events to the audio stream, for example synchronizing audio to MIDI.

Returns
  The stream's current time in seconds, or 0 if an error occurred.

See also
  PaTime, PaStreamCallback, PaStreamCallbackTimeInfo

## Pa_GetStreamWriteAvailable()

signed long Pa_GetStreamWriteAvailable | ( | PaStream * | stream | ) |

Retrieve the number of frames that can be written to the stream without waiting.

Returns
  Returns a non-negative value representing the maximum number of frames that can be written to the stream without blocking or busy waiting or, a PaErrorCode (which are always negative) if PortAudio is not initialized or an error is encountered.

## Pa_GetVersion()

int Pa_GetVersion | ( | void |  | ) |

Retrieve the release number of the currently running PortAudio build. For example, for version "19.5.1" this will return 0x00130501.

See also
  paMakeVersionNumber

## Pa_GetVersionInfo()

const PaVersionInfo* Pa_GetVersionInfo | ( |  | ) |

Retrieve version information for the currently running PortAudio build.

Returns
  A pointer to an immutable PaVersionInfo structure.

Note
  This function can be called at any time. It does not require PortAudio to be initialized. The structure pointed to is statically allocated. Do not attempt to free it or modify it.

See also
  PaVersionInfo, paMakeVersionNumber

Version
  Available as of 19.5.0.

## Pa_GetVersionText()

const char* Pa_GetVersionText | ( | void |  | ) |

Retrieve a textual description of the current PortAudio build, e.g. "PortAudio V19.5.0-devel, revision 1952M". The format of the text may change in the future. Do not try to parse the returned string.

Deprecated:
  As of 19.5.0, use Pa_GetVersionInfo()->versionText instead.

## Pa_HostApiDeviceIndexToDeviceIndex()

PaDeviceIndex Pa_HostApiDeviceIndexToDeviceIndex | ( | PaHostApiIndex | hostApi,
|  | int | hostApiDeviceIndex
| ) |  |

Convert a host-API-specific device index to standard PortAudio device index. This function may be used in conjunction with the deviceCount field of PaHostApiInfo to enumerate all devices for the specified host API.

Parameters

  hostApi | A valid host API index ranging from 0 to (Pa_GetHostApiCount()-1)
  hostApiDeviceIndex | A valid per-host device index in the range 0 to (Pa_GetHostApiInfo(hostApi)->deviceCount-1)

Returns
  A non-negative PaDeviceIndex ranging from 0 to (Pa_GetDeviceCount()-1) or, a PaErrorCode (which are always negative) if PortAudio is not initialized or an error is encountered.

A paInvalidHostApi error code indicates that the host API index specified by the hostApi parameter is out of range.

A paInvalidDevice error code indicates that the hostApiDeviceIndex parameter is out of range.

See also
  PaHostApiInfo

## Pa_HostApiTypeIdToHostApiIndex()

PaHostApiIndex Pa_HostApiTypeIdToHostApiIndex | ( | PaHostApiTypeId | type | ) |

Convert a static host API unique identifier, into a runtime host API index.

Parameters

  type | A unique host API identifier belonging to the PaHostApiTypeId enumeration.

Returns
  A valid PaHostApiIndex ranging from 0 to (Pa_GetHostApiCount()-1) or, a PaErrorCode (which are always negative) if PortAudio is not initialized or an error is encountered.

The paHostApiNotFound error code indicates that the host API specified by the type parameter is not available.

See also
  PaHostApiTypeId

## Pa_Initialize()

PaError Pa_Initialize | ( | void |  | ) |

Library initialization function - call this before using PortAudio. This function initializes internal data structures and prepares underlying host APIs for use. With the exception of Pa_GetVersion(), Pa_GetVersionText(), and Pa_GetErrorText(), this function MUST be called before using any other PortAudio API functions.

If Pa_Initialize() is called multiple times, each successful call must be matched with a corresponding call to Pa_Terminate(). Pairs of calls to Pa_Initialize()/Pa_Terminate() may overlap, and are not required to be fully nested.

Note that if Pa_Initialize() returns an error code, Pa_Terminate() should NOT be called.

Returns
  paNoError if successful, otherwise an error code indicating the cause of failure.

See also
  Pa_Terminate

## Pa_IsFormatSupported()

PaError Pa_IsFormatSupported | ( | const PaStreamParameters * | inputParameters,
|  | const PaStreamParameters * | outputParameters,
|  | double | sampleRate
| ) |  |

Determine whether it would be possible to open a stream with the specified parameters.

Parameters

  inputParameters | A structure that describes the input parameters used to open a stream. The suggestedLatency field is ignored. See PaStreamParameters for a description of these parameters. inputParameters must be NULL for output-only streams.
  outputParameters | A structure that describes the output parameters used to open a stream. The suggestedLatency field is ignored. See PaStreamParameters for a description of these parameters. outputParameters must be NULL for input-only streams.
  sampleRate | The required sampleRate. For full-duplex streams it is the sample rate for both input and output

Returns
  Returns 0 if the format is supported, and an error code indicating why the format is not supported otherwise. The constant paFormatIsSupported is provided to compare with the return value for success.

See also
  paFormatIsSupported, PaStreamParameters

## Pa_IsStreamActive()

PaError Pa_IsStreamActive | ( | PaStream * | stream | ) |

Determine whether the stream is active. A stream is active after a successful call to Pa_StartStream(), until it becomes inactive either as a result of a call to Pa_StopStream() or Pa_AbortStream(), or as a result of a return value other than paContinue from the stream callback. In the latter case, the stream is considered inactive after the last buffer has finished playing.

Returns
  Returns one (1) when the stream is active (ie playing or recording audio), zero (0) when not playing or, a PaErrorCode (which are always negative) if PortAudio is not initialized or an error is encountered.

See also
  Pa_StopStream, Pa_AbortStream, Pa_IsStreamStopped

## Pa_IsStreamStopped()

PaError Pa_IsStreamStopped | ( | PaStream * | stream | ) |

Determine whether the stream is stopped. A stream is considered to be stopped prior to a successful call to Pa_StartStream and after a successful call to Pa_StopStream or Pa_AbortStream. If a stream callback returns a value other than paContinue the stream is NOT considered to be stopped.

Returns
  Returns one (1) when the stream is stopped, zero (0) when the stream is running or, a PaErrorCode (which are always negative) if PortAudio is not initialized or an error is encountered.

See also
  Pa_StopStream, Pa_AbortStream, Pa_IsStreamActive

## Pa_OpenDefaultStream()

PaError Pa_OpenDefaultStream | ( | PaStream ** | stream,
|  | int | numInputChannels,
|  | int | numOutputChannels,
|  | PaSampleFormat | sampleFormat,
|  | double | sampleRate,
|  | unsigned long | framesPerBuffer,
|  | PaStreamCallback * | streamCallback,
|  | void * | userData
| ) |  |

A simplified version of Pa_OpenStream() that opens the default input and/or output devices.

Parameters

  stream | The address of a PaStream pointer which will receive a pointer to the newly opened stream.
  numInputChannels | The number of channels of sound that will be supplied to the stream callback or returned by Pa_ReadStream. It can range from 1 to the value of maxInputChannels in the PaDeviceInfo record for the default input device. If 0 the stream is opened as an output-only stream.
  numOutputChannels | The number of channels of sound to be delivered to the stream callback or passed to Pa_WriteStream. It can range from 1 to the value of maxOutputChannels in the PaDeviceInfo record for the default output device. If 0 the stream is opened as an output-only stream.
  sampleFormat | The sample format of both the input and output buffers provided to the callback or passed to and from Pa_ReadStream and Pa_WriteStream. sampleFormat may be any of the formats described by the PaSampleFormat enumeration.
  sampleRate | Same as Pa_OpenStream parameter of the same name.
  framesPerBuffer | Same as Pa_OpenStream parameter of the same name.
  streamCallback | Same as Pa_OpenStream parameter of the same name.
  userData | Same as Pa_OpenStream parameter of the same name.

Returns
  As for Pa_OpenStream

See also
  Pa_OpenStream, PaStreamCallback

## Pa_OpenStream()

PaError Pa_OpenStream | ( | PaStream ** | stream,
|  | const PaStreamParameters * | inputParameters,
|  | const PaStreamParameters * | outputParameters,
|  | double | sampleRate,
|  | unsigned long | framesPerBuffer,
|  | PaStreamFlags | streamFlags,
|  | PaStreamCallback * | streamCallback,
|  | void * | userData
| ) |  |

Opens a stream for either input, output or both.

Parameters

  stream | The address of a PaStream pointer which will receive a pointer to the newly opened stream.
  inputParameters | A structure that describes the input parameters used by the opened stream. See PaStreamParameters for a description of these parameters. inputParameters must be NULL for output-only streams.
  outputParameters | A structure that describes the output parameters used by the opened stream. See PaStreamParameters for a description of these parameters. outputParameters must be NULL for input-only streams.
  sampleRate | The desired sampleRate. For full-duplex streams it is the sample rate for both input and output

  framesPerBuffer

  The number of frames passed to the stream callback function, or the preferred block granularity for a blocking read/write stream. The special value paFramesPerBufferUnspecified (0) may be used to request that the stream callback will receive an optimal (and possibly varying) number of frames based on host requirements and the requested latency settings. Note: With some host APIs, the use of non-zero framesPerBuffer for a callback stream may introduce an additional layer of buffering which could introduce additional latency. PortAudio guarantees that the additional latency will be kept to the theoretical minimum however, it is strongly recommended that a non-zero framesPerBuffer value only be used when your algorithm requires a fixed number of frames per stream callback.

  streamFlags | Flags which modify the behavior of the streaming process. This parameter may contain a combination of flags ORed together. Some flags may only be relevant to certain buffer formats.

  streamCallback

  A pointer to a client supplied function that is responsible for processing and filling input and output buffers. If this parameter is NULL the stream will be opened in 'blocking read/write' mode. In blocking mode, the client can receive sample data using Pa_ReadStream and write sample data using Pa_WriteStream, the number of samples that may be read or written without blocking is returned by Pa_GetStreamReadAvailable and Pa_GetStreamWriteAvailable respectively.

  userData | A client supplied pointer which is passed to the stream callback function. It could for example, contain a pointer to instance data necessary for processing the audio buffers. This parameter is ignored if streamCallback is NULL.

Returns
  Upon success Pa_OpenStream() returns paNoError and places a pointer to a valid PaStream in the stream argument. The stream is inactive (stopped). If a call to Pa_OpenStream() fails, a non-zero error code is returned (see PaError for possible error codes) and the value of stream is invalid.

See also
  PaStreamParameters, PaStreamCallback, Pa_ReadStream, Pa_WriteStream, Pa_GetStreamReadAvailable, Pa_GetStreamWriteAvailable

## Pa_ReadStream()

PaError Pa_ReadStream | ( | PaStream * | stream,
|  | void * | buffer,
|  | unsigned long | frames
| ) |  |

Read samples from an input stream. The function doesn't return until the entire buffer has been filled - this may involve waiting for the operating system to supply the data.

Parameters

  stream | A pointer to an open stream previously created with Pa_OpenStream.

  buffer

  A pointer to a buffer of sample frames. The buffer contains samples in the format specified by the inputParameters->sampleFormat field used to open the stream, and the number of channels specified by inputParameters->numChannels. If non-interleaved samples were requested using the paNonInterleaved sample format flag, buffer is a pointer to the first element of an array of buffer pointers, one non-interleaved buffer for each channel.

  frames | The number of frames to be read into buffer. This parameter is not constrained to a specific range, however high performance applications will want to match this parameter to the framesPerBuffer parameter used when opening the stream.

Returns
  On success PaNoError will be returned, or PaInputOverflowed if input data was discarded by PortAudio after the previous call and before this call.

## Pa_SetStreamFinishedCallback()

PaError Pa_SetStreamFinishedCallback | ( | PaStream * | stream,
|  | PaStreamFinishedCallback * | streamFinishedCallback
| ) |  |

Register a stream finished callback function which will be called when the stream becomes inactive. See the description of PaStreamFinishedCallback for further details about when the callback will be called.

Parameters

  stream | a pointer to a PaStream that is in the stopped state - if the stream is not stopped, the stream's finished callback will remain unchanged and an error code will be returned.
  streamFinishedCallback | a pointer to a function with the same signature as PaStreamFinishedCallback, that will be called when the stream becomes inactive. Passing NULL for this parameter will un-register a previously registered stream finished callback function.

Returns
  on success returns paNoError, otherwise an error code indicating the cause of the error.

See also
  PaStreamFinishedCallback

## Pa_Sleep()

void Pa_Sleep | ( | long | msec | ) |

Put the caller to sleep for at least 'msec' milliseconds. This function is provided only as a convenience for authors of portable code (such as the tests and examples in the PortAudio distribution.)

The function may sleep longer than requested so don't rely on this for accurate musical timing.

## Pa_StartStream()

PaError Pa_StartStream | ( | PaStream * | stream | ) |

Commences audio processing.

## Pa_StopStream()

PaError Pa_StopStream | ( | PaStream * | stream | ) |

Terminates audio processing. It waits until all pending audio buffers have been played before it returns.

## Pa_Terminate()

PaError Pa_Terminate | ( | void |  | ) |

Library termination function - call this when finished using PortAudio. This function deallocates all resources allocated by PortAudio since it was initialized by a call to Pa_Initialize(). In cases where Pa_Initialise() has been called multiple times, each call must be matched with a corresponding call to Pa_Terminate(). The final matching call to Pa_Terminate() will automatically close any PortAudio streams that are still open.

Pa_Terminate() MUST be called before exiting a program which uses PortAudio. Failure to do so may result in serious resource leaks, such as audio devices not being available until the next reboot.

Returns
  paNoError if successful, otherwise an error code indicating the cause of failure.

See also
  Pa_Initialize

## Pa_WriteStream()

PaError Pa_WriteStream | ( | PaStream * | stream,
|  | const void * | buffer,
|  | unsigned long | frames
| ) |  |

Write samples to an output stream. This function doesn't return until the entire buffer has been written - this may involve waiting for the operating system to consume the data.

Parameters

  stream | A pointer to an open stream previously created with Pa_OpenStream.

  buffer

  A pointer to a buffer of sample frames. The buffer contains samples in the format specified by the outputParameters->sampleFormat field used to open the stream, and the number of channels specified by outputParameters->numChannels. If non-interleaved samples were requested using the paNonInterleaved sample format flag, buffer is a pointer to the first element of an array of buffer pointers, one non-interleaved buffer for each channel.

  frames | The number of frames to be written from buffer. This parameter is not constrained to a specific range, however high performance applications will want to match this parameter to the framesPerBuffer parameter used when opening the stream.

Returns
  On success PaNoError will be returned, or paOutputUnderflowed if additional output data was inserted after the previous call and before this call.